declare const SNODE: unique symbol, SPROXY: unique symbol;
declare type StateNode = {
    [SNODE]?: any;
    [SPROXY]?: any;
    [k: string]: any;
    [k: number]: any;
};
declare type Proxy<T> = {
    get(): any;
    set(): boolean;
};
declare type Wrapped<T> = {
    [P in keyof T]: Proxy<T[P]>;
};
export declare function isWrappable(obj: any): boolean;
export declare function unwrap<T extends StateNode>(item: any): T;
export declare function setProperty(state: StateNode, property: string | number, value: any): void;
export declare function createState<T extends StateNode>(state?: T | Wrapped<T>): (Wrapped<T> | {
    (update: object): void;
    (...path: any[]): void;
    (paths: any[][]): void;
})[];
export {};
